<?php

namespace eBizCharge\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MarkSurchargePaymentAsAppliedResponse StructType
 * @subpackage Structs
 */
class MarkSurchargePaymentAsAppliedResponse extends AbstractStructBase
{
    /**
     * The StatusCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $StatusCode;
    /**
     * The ErrorCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ErrorCode;
    /**
     * The MarkSurchargePaymentAsAppliedResult
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse
     */
    public $MarkSurchargePaymentAsAppliedResult;
    /**
     * The SurchargeInternalId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SurchargeInternalId;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Status;
    /**
     * The Error
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Error;
    /**
     * Constructor method for MarkSurchargePaymentAsAppliedResponse
     * @uses MarkSurchargePaymentAsAppliedResponse::setStatusCode()
     * @uses MarkSurchargePaymentAsAppliedResponse::setErrorCode()
     * @uses MarkSurchargePaymentAsAppliedResponse::setMarkSurchargePaymentAsAppliedResult()
     * @uses MarkSurchargePaymentAsAppliedResponse::setSurchargeInternalId()
     * @uses MarkSurchargePaymentAsAppliedResponse::setStatus()
     * @uses MarkSurchargePaymentAsAppliedResponse::setError()
     * @param int $statusCode
     * @param int $errorCode
     * @param \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse $markSurchargePaymentAsAppliedResult
     * @param string $surchargeInternalId
     * @param string $status
     * @param string $error
     */
    public function __construct($statusCode = null, $errorCode = null, \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse $markSurchargePaymentAsAppliedResult = null, $surchargeInternalId = null, $status = null, $error = null)
    {
        $this
            ->setStatusCode($statusCode)
            ->setErrorCode($errorCode)
            ->setMarkSurchargePaymentAsAppliedResult($markSurchargePaymentAsAppliedResult)
            ->setSurchargeInternalId($surchargeInternalId)
            ->setStatus($status)
            ->setError($error);
    }
    /**
     * Get StatusCode value
     * @return int
     */
    public function getStatusCode()
    {
        return $this->StatusCode;
    }
    /**
     * Set StatusCode value
     * @param int $statusCode
     * @return \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: int
        if (!is_null($statusCode) && !(is_int($statusCode) || ctype_digit($statusCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        $this->StatusCode = $statusCode;
        return $this;
    }
    /**
     * Get ErrorCode value
     * @return int
     */
    public function getErrorCode()
    {
        return $this->ErrorCode;
    }
    /**
     * Set ErrorCode value
     * @param int $errorCode
     * @return \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse
     */
    public function setErrorCode($errorCode = null)
    {
        // validation for constraint: int
        if (!is_null($errorCode) && !(is_int($errorCode) || ctype_digit($errorCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($errorCode, true), gettype($errorCode)), __LINE__);
        }
        $this->ErrorCode = $errorCode;
        return $this;
    }
    /**
     * Get MarkSurchargePaymentAsAppliedResult value
     * @return \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse|null
     */
    public function getMarkSurchargePaymentAsAppliedResult()
    {
        return $this->MarkSurchargePaymentAsAppliedResult;
    }
    /**
     * Set MarkSurchargePaymentAsAppliedResult value
     * @param \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse $markSurchargePaymentAsAppliedResult
     * @return \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse
     */
    public function setMarkSurchargePaymentAsAppliedResult(\eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse $markSurchargePaymentAsAppliedResult = null)
    {
        $this->MarkSurchargePaymentAsAppliedResult = $markSurchargePaymentAsAppliedResult;
        return $this;
    }
    /**
     * Get SurchargeInternalId value
     * @return string|null
     */
    public function getSurchargeInternalId()
    {
        return $this->SurchargeInternalId;
    }
    /**
     * Set SurchargeInternalId value
     * @param string $surchargeInternalId
     * @return \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse
     */
    public function setSurchargeInternalId($surchargeInternalId = null)
    {
        // validation for constraint: string
        if (!is_null($surchargeInternalId) && !is_string($surchargeInternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($surchargeInternalId, true), gettype($surchargeInternalId)), __LINE__);
        }
        $this->SurchargeInternalId = $surchargeInternalId;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get Error value
     * @return string|null
     */
    public function getError()
    {
        return $this->Error;
    }
    /**
     * Set Error value
     * @param string $error
     * @return \eBizCharge\StructType\MarkSurchargePaymentAsAppliedResponse
     */
    public function setError($error = null)
    {
        // validation for constraint: string
        if (!is_null($error) && !is_string($error)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($error, true), gettype($error)), __LINE__);
        }
        $this->Error = $error;
        return $this;
    }
}
